A 100
;* ---------------------------------------------------------
;*  File: LISTING2.ASM
;*  Funktion: Demonstration des INT Befehls fr
;*            BIOS- und DOS-Zugriffe.
;* ---------------------------------------------------------
;*  Assembliere ab Adresse 100H
;*
;*  Start:
;*  Up Scroll des Bildschirms (clear) per INT 10 Funktion
;*  AH 07H, AL - Zeilenzahl -> 0 - clear window
;*  CH - Eckzeile links oben, CL - Eckspalte
;*  DH - Eckzeile unten rechts, DL - Eckspalte
;* ---------------------------------------------------------
         MOV  AX,0600     ;*  up scroll, clear window
         MOV  BH,07       ;*  Attibut normal
         MOV  CX,0000     ;*  linke obere Ecke
         MOV  DX,1850     ;*  rechte untere Ecke
         INT 10           ;*  BIOS Routine rufen
;* ---------------------------------------------------------
;*  Down Scroll eines Fensters per INT 10 Funktion
;*  AH 07H, AL - Zeilenzahl
;*  CH - Eckzeile links oben, CL - Eckspalte
;*  DH - Eckzeile unten rechts, DL - Eckspalte
;*  Es erscheint ein inverses Fenster auf dem Screen
;* ---------------------------------------------------------
         MOV  AX,0700     ;*  down scroll, clear window
         MOV  BH,F0       ;*  Attibut invers+blinkend
         MOV  CX,030F     ;*  linke obere Ecke
         MOV  DX,1040     ;*  rechte untere Ecke
         INT 10           ;*  BIOS Routine rufen
;* ---------------------------------------------------------
;*   Positioniere den Cursor in das Fensters
;*   AH 02H, BH - Bildschirmseite, DL - Spalte,  DH - Zeile
;* ---------------------------------------------------------
         MOV  AH,02       ;*  set cursor
         MOV  BH,00       ;*  Seite 0
         MOV  DX,091B     ;*  Spalte/Zeile
         INT 10           ;*  BIOS Routine rufen
;* ---------------------------------------------------------
;*   Schreibe String auf dem Schirm
;* ---------------------------------------------------------
         CALL 200         ;*  Ausgabe
;* ---------------------------------------------------------
;*  Rckkehr zu MS-DOS
;* ---------------------------------------------------------
         MOV  AX,4C00     ;*  DOS-Code "Exit"
         INT 21           ;*  Terminiere Programm
;*
;*  hier mu eine Leerzeile kommen

A 200
;* ---------------------------------------------------------
;*  Unterprogramm zur Ausgabe eines Textes
;* ---------------------------------------------------------
;*  Output:
         MOV  DX,208      ;*  lade Stringadresse
         MOV  AH,09       ;*  DOS-Code "Write String"
         INT 21           ;*  String ausgeben
         RET              ;*  Ende Unterprogramm
;* ---------------------------------------------------------
;*  Datenbereich mit dem Textstring
;* ---------------------------------------------------------
DB "Der Toolbox Assemblerkurs",0D,0A,"$"
;*
;*  Steueranweisungen fr DEBUG

N DEMO2.COM
R CX
250
W
Q
