(* ------------------------------------------------------ *)
(*                      NOLIST.PAS                        *)
(*       Programm zur Demonstration der Unit Header       *)
(*         (c) 1989 by Ofer Schakowski & TOOLBOX          *)
(* ------------------------------------------------------ *)
PROGRAM NoList2;

USES Crt, Dos, Headers;

CONST
  Mitteilung  : HeaderStr = 'Die Datei enthlt keine '+
                            'lesbaren Informationen.';
VAR
  Zaehler     : WORD;
  Dateiname   : PathStr;
  ZwischenStr : HeaderStr;

PROCEDURE Info;
BEGIN
  Writeln;
  Writeln('Aufruf: NOLIST Datei [ Option / Mitteilung ]');
  Writeln;
  Writeln('Option: -R oder');
  Writeln('        /R(emove)    Entfernen der Mitteilung');
  Writeln;
  Writeln('Voreingestellte Mitteilung:');
  Writeln('       ',Mitteilung);
  Writeln;
  TextAttr := TextAttr + Blink;
  Writeln('Achtung:');
  TextAttr := TextAttr - Blink;
  Writeln('Es wird bei /R(emove) nicht berprft, ob eine'+
          ' Mitteilung gesetzt wurde');
  Writeln('oder nicht. Es werden immer die ersten 128 '+
          'Bytes entfernt !');
  Halt;
END;

BEGIN
  Writeln('NOLIST  Version 1.1  Copyright ' +
          '(c) 1989 by Ofer Schakowski & TOOLBOX');
  IF (ParamCount = 0) THEN Info;
  DateiName   := ParamStr (1);
  ZwischenStr := ParamStr (2);
  FOR Zaehler := 3 TO ParamCount DO
    ZwischenStr := ZwischenStr + ' ' + ParamStr (Zaehler);
  IF (ZwischenStr = '/R') OR (ZwischenStr = '/r') OR
     (ZwischenStr = '-R') OR (ZwischenStr = '-r')
    THEN
      RemoveHeader (DateiName)
    ELSE
      IF (ZwischenStr = '') THEN
        CreateHeader (DateiName, Mitteilung)
      ELSE
        CreateHeader (DateiName, ZwischenStr);
END.
(* ------------------------------------------------------ *)
(*                 Ende von NOLIST.PAS                    *)